<app-title-page></app-title-page>
<div class="default-card">
  <div nz-row>
    <div nz-col [nzLg]="8" [nzMd]="24">
      <h2 class="require-title">Thông tin tài khoản</h2>
    </div>
    <div nz-col [nzLg]="16" [nzMd]="24">
      <form #form="ngForm" (ngSubmit)="login()" nz-form nzLayout="vertical">
        <nz-form-item>
          <nz-form-label>Địa chỉ email - <strong>tài khoản</strong></nz-form-label>
          <nz-form-control [nzValidateStatus]="email.dirty ? (email.invalid  ? 'error' : 'success') : ''">
            <input nz-input [(ngModel)]="user.email"
                   (focusout)="checkEmail()"
                   (focus)="existEmail = false"
                   #email="ngModel"
                   name="email"
                   pattern=".+@.+..+"
                   required/>
            <ng-container *ngIf="email.invalid && email.touched">
              <nz-form-explain *ngIf="email.errors?.required" class="invalid-msg">
                Email không được trống
              </nz-form-explain>
              <nz-form-explain *ngIf="email.errors?.pattern" class="invalid-msg">
                Email không đúng định dạng
              </nz-form-explain>
            </ng-container>

            <nz-form-explain *ngIf="existEmail" class="invalid-msg">
              Tài khoản với email này đã tồn tại
            </nz-form-explain>
          </nz-form-control>
        </nz-form-item>

        <nz-form-item>
          <nz-form-label>Mật khẩu</nz-form-label>
          <nz-form-control [nzValidateStatus]="password.dirty ? (password.invalid  ? 'error' : 'success') : ''">
            <nz-input-group [nzSuffix]="suffixPassword">
              <input nz-input [type]="passwordVisible ? 'text' : 'password'"
                     #password="ngModel"
                     name="password"
                     required
                     minlength="3"
                     maxlength="20"
                     [(ngModel)]="user.password"/>
            </nz-input-group>

            <ng-container *ngIf="password.invalid && password.touched ">
              <nz-form-explain *ngIf="password.errors?.required"
                               class="invalid-msg">
                Mật khẩu không được trống
              </nz-form-explain>
              <nz-form-explain *ngIf="password.errors?.minlength || password.errors?.maxlength"
                               class="invalid-msg">
                Mật khẩu phải từ 3 đến 20 kí tự
              </nz-form-explain>
            </ng-container>
          </nz-form-control>
          <ng-template #suffixPassword>
            <i nz-icon [nzType]="passwordVisible ? 'eye-invisible' : 'eye'"
               (click)="passwordVisible = !passwordVisible"></i>
          </ng-template>
        </nz-form-item>

        <nz-form-item>
          <nz-form-label>Xác nhập mật khẩu</nz-form-label>
          <nz-form-control
            [nzValidateStatus]="confirmPass.dirty ? (confirmPass.invalid || noMatchPassword ? 'error' : 'success') : ''">
            <nz-input-group [nzSuffix]="suffixCfPassword">
              <input nz-input
                     [type]="cfPasswordVisible ? 'text' : 'password'"
                     (focusout)="noMatchPassword = (user.password != user.confirmPassword)"
                     (focus)="noMatchPassword = false"
                     #confirmPass="ngModel"
                     name="cfPassword"
                     required
                     [(ngModel)]="user.confirmPassword"/>
            </nz-input-group>

            <ng-container *ngIf="confirmPass.invalid && confirmPass.touched">
              <nz-form-explain *ngIf="confirmPass.errors?.required" class="invalid-msg">
                Mật khẩu không được trống
              </nz-form-explain>
            </ng-container>

            <ng-container *ngIf="noMatchPassword && user.confirmPassword.length > 0">
              <nz-form-explain class="invalid-msg">
                Mật khẩu xác nhận không khớp với mật khẩu mới
              </nz-form-explain>
            </ng-container>
          </nz-form-control>

          <ng-template #suffixCfPassword>
            <i nz-icon [nzType]="cfPasswordVisible ? 'eye-invisible' : 'eye'"
               (click)="cfPasswordVisible = !cfPasswordVisible"></i>
          </ng-template>
        </nz-form-item>

      </form>
    </div>
  </div>

  <nz-divider></nz-divider>

  <div nz-row>
    <div nz-col [nzLg]="8" [nzMd]="24">
      <h2>Ảnh đại diện</h2>
    </div>
    <div nz-col [nzLg]="16" [nzMd]="24">
      <div class="clearfix">
        <nz-upload
          class="avatar-uploader float-left mr-3"
          nzAction="https://jsonplaceholder.typicode.com/posts/"
          nzName="avatar"
          nzListType="picture-card"
          [nzShowUploadList]="false"
          [nzBeforeUpload]="beforeUpload"
          (nzChange)="handleChange($event)">
          <ng-container *ngIf="!avatarUrl">
            <i class="upload-icon" nz-icon [type]="loading ? 'loading' : 'plus'"></i>
            <div class="ant-upload-text">Upload</div>
          </ng-container>
          <img *ngIf="avatarUrl" [src]="avatarUrl" class="avatar"/>
        </nz-upload>

        <div>
          <h3>Tải lên ảnh mới</h3>
          <p>Kích thước ảnh tối đa 2MB</p>
          <p *ngIf="fileUpload != null">Nhấn vào ảnh để thay đổi</p>
          <button nz-button nzType="danger" *ngIf="fileUpload != null" (click)="fileUpload = null; avatarUrl = null">Xoá ảnh đại diện</button>
        </div>
      </div>
    </div>
  </div>

  <nz-divider></nz-divider>

  <div nz-row style="padding-bottom: 100px">
    <div nz-col [nzLg]="8" [nzMd]="24">
      <h2>Thông tin cá nhân</h2>
    </div>
    <div nz-col [nzLg]="16" [nzMd]="24">
      <div nz-form nzLayout="vertical">

        <nz-form-item>
          <nz-form-label>Họ và tên</nz-form-label>
          <nz-form-control>
            <input nz-input [(ngModel)]="user.fullName"/>
          </nz-form-control>
        </nz-form-item>


        <nz-form-item>
          <nz-form-label>Số điện thoại</nz-form-label>
          <nz-form-control>
            <input nz-input [(ngModel)]="user.phone"/>
          </nz-form-control>
        </nz-form-item>

        <nz-form-item>
          <nz-form-label>Địa chỉ</nz-form-label>
          <nz-form-control>
            <textarea nz-input [(ngModel)]="user.address"></textarea>
          </nz-form-control>
        </nz-form-item>
      </div>

      <div nz-row nzType="flex" nzJustify="space-between">
        <button nz-col nz-button nzType="primary" (click)="submitCreate()"
                [disabled]="existEmail || !form.valid || (user.password != user.confirmPassword) || clicked">Tạo mới
        </button>
        <button nz-col nz-button nzType="default" routerLink="/users">Hủy</button>
      </div>

    </div>
  </div>

</div>
